<script>
	import { onMount } from "svelte";
    import Svelecte from 'svelecte';
    import Hidden from './Hidden.svelte';
	import { getdhaatuLables, fetchList } from "../service/common";
	import {apiData, KrdantaList, combineData, combineList} from "../service/format";
	import { Accordion, AccordionItem,  Card, Col, Container, Row,
    CardBody,
    CardFooter,
    CardHeader,
    CardSubtitle,
    CardText,
    CardTitle,
	Button,
	Form, FormGroup, FormText, Input, Label, Spinner, Alert   } from 'sveltestrap';
	
	let inputSelected = 'DEVANAGARI';
	let outputSelected = 'DEVANAGARI';
	let dhaatus = '';
	let pratyayas = '';
	let scriptOptions = ['DEVANAGARI', 'SLP1'];
	let dhatuLables = [];
	let spinnerShow = false;
	let expected = '';
	let generated = '';
	let alert = false;
	apiData.set([]);

	async function getdhaatuLablesCall () {
		 dhatuLables = await getdhaatuLables('',outputSelected);
        // console.log('came to call',dhatuLables)
         combineData.set(dhatuLables);
	};

    function clearResult() {
          apiData.set([]);
          generated = '';
          expected = '';
        }


	async function submit() {
		spinnerShow=true;
        const tags = dhaatus["label"].split('+')
		let dataValue = await fetchList(tags[0], tags[1], outputSelected, outputSelected);
		spinnerShow=false;
		if(dataValue.expected){
            console.log('came to call',dataValue.padas)
            expected = dataValue.expected[0];
			generated = dataValue.generated;
			apiData.set(dataValue.mods);
			alert = false;
		} else {
			alert = true;
			apiData.set([]);
		}
		
	}


	onMount(async () => {
		getdhaatuLablesCall();

	})
</script>

<container class="d-flex flex-column p-2 ">
	<!-- <Row>
    	<Col> <h4 class="alert-heading text-capitalize">Krdanta Analyzer​</h4>​</Col>
  	</Row> -->
	<Row>
		<Col class="col-sm-9">
			<Card >
				<CardHeader>
					<CardTitle>Validated Krdanta Forms</CardTitle>
				</CardHeader>
				<CardBody class="minHeight">
			<div class="mx-auto  rounded">
				<div>
					<div class="row">
						<div class="col-sm-4">
							<div class="form-group">
                            <!--
								<select class="form-select selectpicker" bind:value={dhaatus}>
									<option value=''>Select Dhaathu + pratyaya</option>
									{#each $combineList as value}
										<option>{value}</option>
									{/each}
								</select>
                                -->    
                                
                                 <Svelecte options={$combineList}
                                    inputId="listSelect"
                                     bind:readSelection={dhaatus}
                                    placeholder="Select Dhaatu"
                                    ></Svelecte>
                                    
							</div>
						</div>
						<div class="col-sm-3">
							<div class="form-group d-flex m-auto">
								<button type="button" class="btn btn-primary" style="margin-right: 5px;" on:click={submit}>Search</button>
								<button type="button" class="btn btn-secondary" style="margin-right: 5px;" on:click={clearResult}>Clear</button>
								{#if spinnerShow}
									<Spinner primary/>
								{/if}
							</div>
						</div>
					</div>
					
				</div>
				{#if alert}
				<div class="alert alert-danger mt-5" role="alert">
					<h4 class="alert-heading text-capitalize">No records found</h4>
					Please try with diffrent search
					.
				</div>
				{/if}
                {#if generated || expected}
                <div class="mt-5">
                    <div>
                        <div class="row">
                            <dd class="col-sm-6">
                                
                            <div class="row">
                                <dt class="col-sm-3">Generated:</dt>  <dd class="col-sm-9">{generated}</dd>
                            </div>
                        </dd>
                        <dd class="col-sm-6">
                            <div class="row">
                                <dt class="col-sm-3">Expected:</dt> <dd class="col-sm-9">{expected}</dd>
                            </div>
                        
                        </dd>
                        </div>
                    </div>	
                </div>
                {/if}
				{#if $KrdantaList.length>=1}
				<div>
					<div class="row">
						
							<dt class="col-sm-3">	Generation Process</dt>
					
					</div>
					<div>
						<table class="table table-striped">
							<thead class="thead-dark">
							  <tr>
								<th scope="col" class="col-md-1">Sutra Id</th>
								<th scope="col" class="col-md-5">Sutra text</th>
								<th scope="col">Padas</th>
								<th scope="col">Curent state</th>
								<!-- <th scope="col">Varnas</th> -->
							  </tr>
							</thead>
							<tbody>
							{#each $KrdantaList as item}	
							  <tr>
								<th scope="row">{item.sutra_id}</th>
								<td class="text-break">{item.sutra_text}</td>
								<td>{item.out_padas}</td>
								<td>{item.out_form}</td>
								<!-- <td>{item.text3}</td> -->
							  </tr>

                              <tr id="{item.seqno}">
                                  <td colspan="4">
                                     <Hidden data="{item}"></Hidden>
                                  </td>
                              </tr>
							{/each}  
							</tbody>
						  </table>
					</div>
				</div>
				{/if}
			</div>
			</CardBody>
			</Card>
		</Col>
		<Col class="col-sm-16">
		<Card >
			<CardHeader>
				<CardTitle>Filter</CardTitle>
			</CardHeader>
			<CardBody>
				<CardSubtitle>Preferences</CardSubtitle>
				<CardText class="mt-2">
					<Accordion stayOpen>
						<!-- <AccordionItem active header="Input script">
							<select class="form-select selectpicker" bind:value={inputSelected}>
								<option>Select input script</option>
							{#each scriptOptions as value}
								<option value={value}  > {value}</option>
							{/each}
						</select>
						</AccordionItem> -->
						<AccordionItem active header="script">
							<select class="form-select selectpicker" bind:value={outputSelected} on:change={getdhaatuLablesCall}>
							
							{#each scriptOptions as value}
								<option value={value}  > {value}</option>
							{/each}
							</select>
						</AccordionItem>
					</Accordion>
				</CardText>
			</CardBody>
		</Card>
		</Col>
	</Row>
</container>
<style>
	main {
		text-align: center;
		padding: 1em;
		max-width: 240px;
		margin: 0 auto;
	}

	h1 {
		color: #ff3e00;
		text-transform: uppercase;
		font-size: 4em;
		font-weight: 100;
	}

	@media (min-width: 640px) {
		main {
			max-width: none;
		}
	}
</style>
